(define (domain dnf)

(:requirements :typing)

(:types 
	money card transfer - method
        product
)


(:predicates
  (paid-by-money ?m - money ?p - product)
  (paid-by-card ?c - card ?p - product)
  (paid-by-transfer ?t - transfer ?p - product)
  (enough-credit ?m - method)
  (shipped ?p - product)
)

(:action pay-by-money
  :parameters 
    (?m - money ?p - product)
  :precondition
    (enough-credit ?m)
    
  :effect 
    (and (paid-by-money ?m ?p) (not (enough-credit ?m)))
  
)

(:action pay-by-card
  :parameters 
    (?m - card ?p - product)
  :precondition
    (enough-credit ?m)
    
  :effect 
    (and (paid-by-card ?m ?p) (not (enough-credit ?m)))
  
)

(:action pay-by-transfer
  :parameters 
    (?m - transfer ?p - product)
  :precondition
    (enough-credit ?m)
    
  :effect 
    (and (paid-by-transfer ?m ?p) (not (enough-credit ?m)))
  
)


(:action ship
  :parameters 
    (?p - product ?m - money ?c - card ?t - transfer)
  :precondition
    (or (paid-by-money ?m ?p)
        (paid-by-card ?c ?p)
        (paid-by-transfer ?t ?p))
    
  :effect 
    (shipped ?p)
  
)


)

